Con                  
                                                           
  _CLKMODE = XTAL1 + PLL16X                              
  _XINFREQ = 5_000_000
  
  RXPIN = 1  'prop i/o to Pi model B P1-Pin8(gpio14 TXD)
  TXPIN = 2  'prop i/o to Pi model B P1-Pin10(gpio15 RXD)
   
  DYNA  = 0  'dynamixel servo bus i/o         
  CAMX  = 1  'dyna servo id x camera platform 
  CAMY  = 2  'dyna servo id y camera platform     
  MARM  = 3  'dyna servo id main arm        
  LGRP  = 4  'dyna servo id left gripper      
  RGRP  = 5  'dyna servo id right gripper    
  SKIP  = 2  'skip amount per each update for dyna servos

Var

  long xAxis, yAxis, zAxis, x, y
     
Obj
    
  fds : "fullduplexserial"
  dyn : "dynacomv4"
                            
Pub Main

  dyn.start(DYNA, 1_000_000)
  fds.start(RXPIN, TXPIN, 0, 115_200) 
  initRobot
  
  repeat
    centerCamera
    
Pub centerCamera                                            
                                
  x := dyn.getsrvpos(CAMX)  
  repeat
    objectDetect
    case xAxis                                        
      0..42   : x += 10                               
                dyn.setsrvpos(CAMX, x <#= 750)

      43..49  : x += 1
                dyn.setsrvpos(CAMX, x <#= 750)                
                                                      
      50..60  : quit

      61..67  : x -= 1
                dyn.setsrvpos(CAMX, x #>= 250)                                           
                                                      
      68..109 : x -= 10
                dyn.setsrvpos(CAMX, x #>= 250)
                     
  y := dyn.getsrvpos(CAMY)                                                    
  repeat
    objectDetect
    case yAxis                                        
      0..25  : y += 5                                  
               dyn.setsrvpos(CAMY, y <#= 750)

      26..37 : y += 1
               dyn.setsrvpos(CAMY, y <#= 750)               
                                                      
      38..42 : quit

      43..54 : y -= 1
               dyn.setsrvpos(CAMY, y #>= 475)                                          
                                                      
      55..79 : y -= 5                                
               dyn.setsrvpos(CAMY, y #>= 475)       

Pub objectDetect | zl, zu                   'object detect tracking info from pi  
                                            'xAxis = 0 to 109 horizontal lft/rgt  
  repeat                                    'yAxis = 0 to 79 vertical up/dwn      
    if fds.rxcheck == "!"                   'zAxis = 0 to word size sm/lg
      if fds.rxtime(10) == "&"                                                   
        xAxis := fds.rxtime(10)                                                  
        yAxis := fds.rxtime(10)                                                  
        zl := fds.rxtime(10)                                                     
        zu := fds.rxtime(10)                                                     
        zAxis := zl + zu << 8                                                     
        return                                                                    

Pub initRobot                               'set initial robot servo positions   
                        
  dyn.setsrvpos(CAMX, 512) 'lower# = cw, higher = ccw 0-1023                   
  dyn.setsrvpos(CAMY, 575) 'lower# = down, higher# = up                        
  dyn.setsrvpos(MARM, 370) 'main arm level with ground                         
  dyn.setsrvpos(LGRP, 550) 'left gripper claw open                             
  dyn.setsrvpos(RGRP, 490) 'right gripper claw open                            
  waitcnt(clkfreq*2+cnt)   'delay for servo position change                    
                                                                               